#!/usr/bin/env node

const { cloneViaCli } = require("../apiConfigUtils/cloneViaCli");
const { setupHusky } = require("../pre-commit/huskySetup/setupHusky");
const { createEslintConfigFile } = require('../utils/createEslintConfigFile');
const { Logger } = require("../utils/Logger");
const { handleIfFalse_ExceptionCase } = require("../utils/getScripts");
const { arePluginsInstalled } = require("../utils/PluginsInstallationUtils/arePluginsInstalled");
const { executeSynchronizedCommands } = require("../utils/executeSyncCommands");
const { execSync } = require('child_process');
const { getFsUtils } = require("../utils/getFsUtils");

function isGitIntialized(){
    const isGit = executeSynchronizedCommands(execSync,['git status'],'',"git not intialized.. ",false,true)
    return isGit;
}

async function postInstall() {
    try {
        getFsUtils()
        isGitIntialized() ?  await handleIfFalse_ExceptionCase('Some issue occurred in setting up husky.',setupHusky,null) : null
        await handleIfFalse_ExceptionCase('Make sure zgit.csez.zohocorpin.com is accessible',cloneViaCli,null);
        await handleIfFalse_ExceptionCase('Some issue occurred in creating eslint config file.',createEslintConfigFile,null);
        Logger.log(Logger.SUCCESS_TYPE, 'Pre commit setup successful');
        arePluginsInstalled()
    } catch (error) {
        Logger.log(Logger.FAILURE_TYPE, `Kindly retry npm install. & ${error.message}`);
    }
}


postInstall();


